﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemyCode : MonoBehaviour {

	private Rigidbody2D myRigidbody2D;
	public Transform target;
	public int moveSpeed;
	public int rotationSpeed;

	// Use this for initialization
	void Start () {
		myRigidbody2D = GetComponent<Rigidbody2D> ();
		target = GameObject.Find ("Player").transform;
	}
	
	// Update is called once per frame
	void Update () {
		if (target != null) {
			Vector3 dir = target.position - target.position;
			if (dir != Vector3.zero)
				transform.rotation = Quaternion.Slerp (transform.rotation,
					Quaternion.FromToRotation (Vector3.right, dir),
					rotationSpeed * Time.deltaTime);

			transform.position += (target.position - transform.position).normalized	* moveSpeed * Time.deltaTime;
		
		}
		myRigidbody2D.velocity = Vector3.zero;
		if(Vector3.Distance(transform.position, Camera.main.transform.position) > 30){
			GameObject.Destroy(gameObject);
		}
	}

	void OnTriggerEnter2D(Collider2D coll)
	{

		if (coll.gameObject.tag == "Bullet")
		{
			transform.GetComponent<Collider2D>().enabled = false;
			transform.GetComponent<Animator>().SetTrigger("Die");
			GameObject.Destroy(gameObject, 2f);
			GameObject.Destroy(coll.gameObject);
		}
	}
}