﻿using UnityEngine;
using System.Collections;


public class Control : MonoBehaviour {

	public GameObject bullet;
	public GameObject wave;

	public GameObject bulletPosition;
	public GameObject wavePosition;

	public float maxY;
	public float minY;

	public float movementSpeed;
	public float bulletSpeed;
	public float forceWave;

	public float frequencyWaves;
	public float frequencyShoots;

	public float maxVel;

	public float freezeTime;
	public AudioClip dieSound;

	private float lastWave;
	private float lastShoot;

	private float leftJoyX;
	private float leftJoyY;

	private float rightJoyX;
	private float rightJoyY;

	private Rigidbody2D rBody2D;

	private bool startMovin = false;
	private bool freeze = false;

	private float startGravityScale;
	private float unfreeze;

	public float minFrq;
	public float maxFrq;
	
	private float[] freqData;
	private int nSamples = 1024;
	private float fMax;

	//ChemaTestin'
	public float w8m8Beginning;
	public float w8ABitIn;
	private float w8ABitInThisTime;
	public float w8ThisInstant;
	private float w8ThisBitm8 = 0f;


	// Use this for initialization
	void Start () {
		lastWave += Time.deltaTime;
		lastShoot += Time.deltaTime;
		rBody2D = transform.GetComponent<Rigidbody2D>();
		startGravityScale = rBody2D.gravityScale;
		rBody2D.gravityScale = 0;

		freqData = new float[nSamples];
		fMax = AudioSettings.outputSampleRate/2;

		//ChemaTestin'
		w8ABitInThisTime = w8ABitIn;
	}
	
	// Update is called once per frame
	void Update () {
		if (!freeze) {
			leftJoyX = Input.GetAxis ("LeftJoystickX") * movementSpeed;
			leftJoyY = Input.GetAxis ("LeftJoystickY") * movementSpeed;

			//rotate Player
			Vector3 diff = new Vector2 (leftJoyX, leftJoyY);
			diff.Normalize ();
		
			float rot_z = Mathf.Atan2 (diff.y * -1, diff.x) * Mathf.Rad2Deg;

			if ((leftJoyX != 0 || leftJoyY != 0) && Time.timeSinceLevelLoad > 3f && !transform.GetComponent<Animator>().GetCurrentAnimatorStateInfo(0).IsName("Hit")) {
				startMovin = true;
				rBody2D.gravityScale = startGravityScale;
				transform.rotation = Quaternion.Euler (0f, 0f, rot_z - 90);
				transform.GetComponent<AudioSource> ().enabled = true;
			}

			if (startMovin && !transform.GetComponent<Animator>().GetCurrentAnimatorStateInfo(0).IsName("Hit")) {
				//create wave and shit
				transform.GetComponent<Animator>().SetTrigger("Fly");

				//ChemaTestin'
				if ((w8m8Beginning) <= 0f) {

					if ((w8ThisBitm8) <= 0f) {

						w8ABitInThisTime -= Time.deltaTime;

						//DONOTTOUCHTHESTUFFBETWEENTHIS
						if (lastWave + frequencyWaves <= Time.timeSinceLevelLoad) {
							//if ((lastWave + frequencyWaves <= Time.timeSinceLevelLoad) && BandVol(minFrq, maxFrq) > .04f && BandVol(minFrq, maxFrq) < 1.2) {
							GameObject wavego; 
							wavego = Instantiate (wave, transform.position, transform.rotation) as GameObject;
							Rigidbody2D rb2wa = wavego.GetComponent<Rigidbody2D> ();

							rb2wa.AddForce ((wavePosition.transform.position - transform.position) * forceWave);
							wavego.transform.rotation = wavePosition.transform.rotation;

							lastWave = Time.timeSinceLevelLoad;

							if (rBody2D.velocity.magnitude < maxVel) {
								rBody2D.AddForce ((transform.position - wavePosition.transform.position) * movementSpeed);
							}
							//ANDTHIS
						}

						if (w8ABitInThisTime <= 0f) {
							w8ABitInThisTime = w8ABitIn;
							w8ThisBitm8 = w8ThisInstant;
						}

					} else {
						w8ThisBitm8 -= Time.deltaTime;
					}
				} else {
					w8m8Beginning -= Time.deltaTime;
				}

				
					//DONOTTOUCHFROMTHIS
					Camera.main.GetComponent<SpawnerOfEnemies>().enabled = true;
				
					foreach (GameObject go in GameObject.FindGameObjectsWithTag("Spawner")) {
						go.GetComponent<RandonSpawnSat>().enabled = true;
					}
					//TOTHIS
				}

				//Disparos
				rightJoyX = Input.GetAxis ("RightJoystickX");
				rightJoyY = Input.GetAxis ("RightJoystickY");

				if ((rightJoyX != 0 || rightJoyY != 0) && !transform.GetComponent<Animator>().GetCurrentAnimatorStateInfo(0).IsName("Hit")) {
					Vector3 diffB = new Vector2 (rightJoyX, rightJoyY);
					diffB.Normalize ();
			
					float rot_b = Mathf.Atan2 (diffB.y * -1, diffB.x) * Mathf.Rad2Deg;
			
					if (rightJoyY != 0 || rightJoyX != 0) {
						bulletPosition.transform.rotation = Quaternion.Euler (0f, 0f, rot_b - 90);

						if (lastShoot + frequencyShoots <= Time.timeSinceLevelLoad) {
							GameObject bulletLocal;
							bulletLocal = Instantiate (bullet, bulletPosition.transform.position, bulletPosition.transform.rotation) as GameObject;

							bulletLocal.GetComponent<Rigidbody2D> ().AddForce (bulletLocal.transform.up * bulletSpeed);

							lastShoot = Time.timeSinceLevelLoad;
						}
					}
				}

				//Que no se salga de camara
				Vector3 bottomLeft = Camera.main.ScreenToWorldPoint (Vector3.zero);
				Vector3 topRight = Camera.main.ScreenToWorldPoint (new Vector3 (
				Camera.main.pixelWidth, Camera.main.pixelHeight));
			
				Rect cameraRect = new Rect (
				bottomLeft.x,
				bottomLeft.y,
				topRight.x - bottomLeft.x,
				topRight.y - bottomLeft.y);

				transform.position = new Vector3 (
				Mathf.Clamp (transform.position.x, cameraRect.xMin + 1, cameraRect.xMax - 1),
				Mathf.Clamp (transform.position.y, minY, maxY),
				transform.position.z);
			}
			if (Time.timeSinceLevelLoad > unfreeze) {
				freeze = false;
				transform.GetComponent<Animator>().SetTrigger("Fly");
			}
		if(transform.GetComponent<Animator>().GetCurrentAnimatorStateInfo(0).IsName("Hit") && (Input.GetButton("A") ||Input.GetButton("Start"))){
			Application.LoadLevel(Application.loadedLevel);
		}
	}

	void OnTriggerEnter2D(Collider2D other)
	{
		if (other.transform.tag == "Enemy")
		{
			muere();
		}
		if (other.transform.tag == "Ice") {
			freeze = true;
			unfreeze = Time.timeSinceLevelLoad + freezeTime;
			transform.GetComponent<Animator>().SetTrigger("Zap");
		}
	}

	private void muere(){
		startMovin = false;
		transform.GetComponent<AudioSource>().PlayOneShot(dieSound, 1);
		transform.GetComponent<Animator> ().SetTrigger ("Hit");
	}
	
	private float BandVol(float fLow, float fHigh) {
		
		fLow = Mathf.Clamp(fLow, 20, fMax); // limit low...
		fHigh = Mathf.Clamp(fHigh, fLow, fMax); // and high frequencies
		// get spectrum
		transform.GetComponent<AudioSource>().GetSpectrumData(freqData, 0, FFTWindow.BlackmanHarris); 
		float n1 = Mathf.Floor(fLow * nSamples / fMax);
		float n2 = Mathf.Floor(fHigh * nSamples / fMax);
		float sum = 0;
		// average the volumes of frequencies fLow to fHigh
		for (float i = n1; i<=n2; i++){
			sum += (float) freqData[(int)i];
		}
		return sum / (n2 - n1 + 1);
	}

}
